// cp52cl1a.c

#include	<windows.h>
#include	"cp52cl1a.h"

#ifdef APP_SYNC
	CRITICAL_SECTION	critSec;
	volatile short		critCnt = 0;
#endif

/*	샂[hffe[u	1:		*/
WORD mod_tbl[128] = {
/*  x0 x1 x2 x3 x4 x5 x6 x7 x8 x9 xa xb xc xd xe xf	*/
	 1, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0,	/* 00-0f */
	 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0, 1, 0, 0,	/* 10-1f */
	 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0,	/* 20-2f */
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 30-3f */
	 0, 1, 1, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 0,	/* 40-4f */
	 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 50-5f */
	 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,	/* 60-6f */
	 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0		/* 70-7f */
};

WORD	g_elspol[16] = { 0 };

/* foCX֌W̊֐ */
/* {[hCfoCX̎擾 */
/*  F{[h̃AhXCfoCX̃AhX */
DWORD hcp52c_GetDevInfo(DWORD* DevCnt, HCP52CINFO* DevInfo)
{
	DWORD		dwDevCnt;			/* CPD5212{[h */
	DWORD		dwRet;				/* ߂l */
	DWORD		dwIx;
	HCP52CINFO	HpcDevInfo[16];		/* CPD5212foCX */

	/* {[h擾 */
	dwRet = cp52c_GetDeviceCount(&dwDevCnt);				
	if( dwRet )									return dwRet;

	/* {[h0܂16ȏ̎̓G[ */
	if((dwDevCnt == 0) || (16 <= dwDevCnt))		return ILLEGAL_PRM;

	*DevCnt = dwDevCnt;
	
	/* foCX擾 */
	dwRet = cp52c_GetDeviceInfo(&dwDevCnt, &HpcDevInfo[0]);	
	if( dwRet )									return dwRet;

	for( dwIx = 0; dwIx < dwDevCnt; dwIx++ ) {
		*DevInfo = HpcDevInfo[dwIx];
		*DevInfo++;
	}
	return 0;
}

/* foCX̃I[vCfoCX̏	*/
/* FfoCXnh̃AhXCfoCX̃AhX */
DWORD hcp52c_DevOpen(DWORD* hDeviceID, HCP52CINFO* DevInfo)
{
	WORD	wAx;			/* 				*/
	DWORD	hDevID;			/* foCXnh	*/
	DWORD	dwRet;			/* ߂l			*/

	/* foCXI[v */
	dwRet = cp52c_OpenDevice(&hDevID, DevInfo);
	if(dwRet)									return dwRet;
	else		*hDeviceID = hDevID;

#ifdef APP_SYNC
	if( critCnt == 0 ) {
		InitializeCriticalSection( &critSec );
		critCnt++;
	}
#endif

	g_elspol[hDevID & 0xf] = 0;

	/* IvV|[gݒ */
	dwRet |= cp52c_wPortW(hDevID, CP52C_ELS_PRT, 0);	/* ELSɐI|[g(B) */
	dwRet |= cp52c_wPortW(hDevID, CP52C_CP4_PRT, 0);	/* Rp[^4o͐ؑփ|[g(o͕s) */
	dwRet |= cp52c_wPortW(hDevID, CP52C_CP5_PRT, 0);	/* Rp[^5o͐ؑփ|[g(o͕s) */
	dwRet |= cp52c_wPortW(hDevID, CP52C_X1C_PRT, 0);	/* X1-U1CMPo͐ؑփ|[g(CMP3o) */
	dwRet |= cp52c_wPortW(hDevID, CP52C_X2C_PRT, 0);	/* X2-U3CMPo͐ؑփ|[g(CMP3o) */
	dwRet |= cp52c_wPortW(hDevID, CP52C_INT_PRT, 0);	/* Cl[u|[g(o͕s) */
	dwRet |= cp52c_wPortW(hDevID, CP52C_FIL_PRT, 0);	/* GR[_tB^|[g */

	/* WX^ */
	dwRet |= cp52c_wCmdW( hDevID, X1_AX, 0x04 );		/* X1-U1\tgEFAZbg */
	dwRet |= cp52c_wCmdW( hDevID, X2_AX, 0x04 );		/* X2-U2\tgEFAZbg */
	dwRet |= cp52c_wCmdW( hDevID, X3_AX, 0x04 );		/* X3-U3\tgEFAZbg */

	for(wAx = X1_AX; wAx < M_AX; wAx++) {
		/* WX^(x[XxWX^:PRFL = 200) */
		dwRet |= hcp52c_wReg (hDevID, wAx, 0x81, 200);

		/* WX^(쑬xWX^:PRFH = 2000) */
		dwRet |= hcp52c_wReg (hDevID, wAx, 0x82, 2000);

		/* WX^([gWX^) */
		/* 		NbNg = 19,660,800Hz,  =  = 0.5b */
		/* 		PRFH = 2000, PRFL = 200, PRUR:[g */
		/* 		(b) = (PRFH - PRFL) * (PRUR + 1) * 4 / 19660800 */
		/* 		PRUR = 1364 */
		dwRet |= hcp52c_wReg (hDevID, wAx, 0x83, 1364);

		/* WX^({ = 1{, PRMG = 299) */
		dwRet |= hcp52c_wReg (hDevID, wAx, 0x85, 299);

		/* WX^(샂[h:PRMD = 0x8008000) */
		dwRet |= hcp52c_wReg (hDevID, wAx, 0x87, 0x8008000);

		/* WX^(ړʕ␳x:RFA = 200) */
		dwRet |= hcp52c_wReg (hDevID, wAx, 0x9b, 200l);

		/* WX^(ݒ1:RENV1 = 0x20434004) */
		/* 		wߏo:ʃpXw߂̐_ */
		/* 		OLS & DLS & SVALM = B, INPOS = A,  */
		/* 		ELS & SVALM͎~,DLSo = ̂,ׯȂ, */
		/* 		޴װ_Aرo͂Ȃ */
		dwRet |= hcp52c_wReg (hDevID, wAx, 0x9c, 0x20434004);

		/* 	ėpo͐ݒ蓙 */
		/* WX^(ݒ2:RENV2 = 0x0020fd55) */
		dwRet |= hcp52c_wReg(hDevID, wAx, 0x9d, 0x0020fd55);

		/* WX^(ݒ3:RENV3 = 0x00f00002) */
		/* 		_AFݻ+ݺތ_A(OLS+Z),  */
		/* 		CLROFFON & _Aر  */
		dwRet |= hcp52c_wReg (hDevID, wAx, 0x9e, 0x00f00002);

		/* WX^(CxgINTݒ:RIRQ = 1(~) */
		dwRet |= hcp52c_wReg (hDevID, wAx, 0xac, 1);

		/* SVON OFF */
		dwRet |= cp52c_wCmdW(hDevID, wAx, 0x10);

		/* SVRST OFF */
		dwRet |= cp52c_wCmdW(hDevID, wAx, 0x11);

		/* ~ */
		dwRet |= cp52c_wCmdW(hDevID, wAx, 0x4a);
	}
	return dwRet;
}

/********************************************************/
/* foCX̃N[Y 									*/
/* 		FfoCXnh 							*/
/********************************************************/
DWORD hcp52c_DevClose(DWORD hDevID)
{
	DWORD	dwRet;						/* ߂l */
	
	g_elspol[hDevID & 0xf] = 0;
	dwRet = cp52c_CloseDevice(hDevID);	/* foCX̃N[Y */
#ifdef APP_SYNC
	if( dwRet == 0 ) {
		critCnt--;
		if( critCnt == 0 ) {
			DeleteCriticalSection( &critSec );
		}
	}
#endif
	return dwRet;
}

/*===============================================================*/
/*							ݒn̊֐					 */
/*===============================================================*/
/********************************************************/
/* _A̐ݒ 									*/
/* 		FfoCXnhCC_A[h 		*/
/********************************************************/
DWORD hcp52c_SetOrgMode(DWORD hDevID, WORD axis, WORD mode)
{
	DWORD	dwRet;				/* ߂l */
	DWORD	dwData;

	/* ԍ0`11ȊO܂ */
	/* _A[h0`12ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM; 
	if((mode < 0) || (mode > 12))			return ILLEGAL_PRM;

	/* WX^3(RENV3)Ǎ */
	dwRet = hcp52c_rReg(hDevID, axis, 0xde, &dwData);
	if(dwRet)								return dwRet;

	/* Orgmode9̎CCTR2͂w߈ʒuɂ */
	/* (Orgmode9ȊO̎CCTR2͂͋@Bʒu) */
	if(mode == 9) {
		dwData &= (DWORD)~0x00000300;
		dwData |= (DWORD) 0x00000100;
	}
	dwData &= (DWORD)~0x0000000f;
	dwData |= mode;

	/* WX^3(RENV3) */
	dwRet = hcp52c_wReg(hDevID, axis, 0x9e, dwData);
	return dwRet;
}

/************************************************************************/
/* \tg~bg̐ݒ 												*/
/* 		FfoCXnhCC+SLS,-SLS,SLSgp/sgpC~@ 	*/
/************************************************************************/
DWORD hcp52c_SetSls(DWORD hDevID, WORD axis, long psls, long msls, WORD selctr, WORD stop)
{
	DWORD	dwRet;			/* ߂l */
	DWORD	dwEnv;

	/* ԍ0`11ȊO */
	/* \tg~bggp+SLS < -SLS͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))		return 0x100;
	if((selctr) && (psls <= msls))				return 0x100;

	/* WX^4(RENV4)Ǎ */
	dwRet = hcp52c_rReg(hDevID, axis, 0xdf, &dwEnv);
	if(dwRet)									return dwRet;

	if(!selctr) {
	/* SLSsgp */
		dwEnv &= 0xffffe3e3;
	} else {
	/* SLSgp */
		/* +SLSf[^ݒ */
		dwRet = hcp52c_wReg(hDevID, axis, 0xa7, psls);
		if(dwRet)								return dwRet;

		/* -SLSf[^ݒ */
		dwRet = hcp52c_wReg(hDevID, axis, 0xa8, msls);
		if(dwRet)								return dwRet;

		dwEnv &= 0xffff0000;
		dwEnv |= 0x00001818;
		if(stop)	dwEnv |= 0x00004040;
		else		dwEnv |= 0x00002020;
	}
	/* WX^4(RENV4) */
	dwRet = hcp52c_wReg(hDevID, axis, 0x9f, dwEnv);
	return dwRet;
}

/********************************************************/
/* ELS̐ݒ 											*/
/* 		FfoCXnhCCɐC~@ 		*/
/********************************************************/
DWORD hcp52c_SetEls(DWORD hDevID, WORD axis, WORD pol, WORD stop)
{
	WORD	wData;
	DWORD	dwRet;				/* ߂l */
	DWORD	dwData;

	/* ԍ0`11ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;

	wData = g_elspol[hDevID & 0xf];

	if(pol) wData |= (WORD) (0x01 << axis);	/* A */
	else 	wData &= (WORD)~(0x01 << axis);	/* B */

	/* ELSɐ|[g */
	dwRet = cp52c_wPortW(hDevID, CP52C_ELS_PRT, wData);
	if(dwRet)								return dwRet;

	/* WX^P(RENV1)Ǎ */
	dwRet = hcp52c_rReg(hDevID, axis, 0xdc, &dwData);
	if(dwRet)								return dwRet;

	if(stop)	dwData |= (DWORD) 0x8;	/* ~ */
	else		dwData &= (DWORD)~0x8;	/* ~ */

	/* WX^P(RENV1) */
	dwRet = hcp52c_wReg(hDevID, axis, 0x9c, dwData);
	if( dwRet == 0 ) g_elspol[hDevID & 0xf] = wData;
	return dwRet;
}

/********************************************************/
/* OLS̐ݒ 											*/
/* 		FfoCXnhCCɐ 				*/
/********************************************************/
DWORD hcp52c_SetOls(DWORD hDevID, WORD axis, WORD pol)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;

	/* WX^P(RENV1)Ǎ */
	dwRet = hcp52c_rReg(hDevID, axis, 0xdc, &dwData);
	if(dwRet)								return dwRet;

	if(pol) dwData |= (DWORD) 0x80;	/* A */
	else	dwData &= (DWORD)~0x80;	/* B */

	/* WX^P(RENV1) */
	dwRet = hcp52c_wReg(hDevID, axis, 0x9c, dwData);
	return dwRet;
}

/********************************************************/
/* SVALM̐ݒ 											*/
/* 		FfoCXnhCCɐC~@ 		*/
/********************************************************/
DWORD hcp52c_SetSvAlm(DWORD hDevID, WORD axis, WORD pol, WORD stop)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;

	/* WX^P(RENV1)Ǎ */
	dwRet = hcp52c_rReg(hDevID, axis, 0xdc, &dwData);
	if(dwRet)								return dwRet;

	if(pol) dwData |= (DWORD) 0x200;		/* A */
	else	dwData &= (DWORD)~0x200;		/* B */

	if(stop)	dwData |= (DWORD) 0x0100;	/* ~ */
	else		dwData &= (DWORD)~0x0100;	/* ~ */

	/* WX^P(RENV1) */
	dwRet = hcp52c_wReg(hDevID, axis, 0x9c, dwData);
	return dwRet;
}

/********************************************************/
/* INPOS̐ݒ 											*/
/* 		FfoCXnhCCgp/sgpCɐ 	*/
/********************************************************/
DWORD hcp52c_SetInpos(DWORD hDevID, WORD axis, WORD enable, WORD pol)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;

	/* 샂[h(RMD)Ǎ */
	dwRet = hcp52c_rReg(hDevID, axis, 0xd7, &dwData);
	if(dwRet)								return dwRet;

	if(enable)	dwData |= (DWORD) 0x200;	/* gp */
	else		dwData &= (DWORD)~0x200;	/* sgp */

	/* 샂[h(PRMD) */
	dwRet = hcp52c_wReg(hDevID, axis, 0x87, dwData);
	if(dwRet)								return dwRet;

	if(enable) {
	/* WX^P(RENV1)Ǎ */
		dwRet = hcp52c_rReg(hDevID, axis, 0xdc, &dwData);
		if(dwRet)							return dwRet;

		if(pol) dwData |= (DWORD) 0x400000;	/* A */
		else	dwData &= (DWORD)~0x400000;	/* B */

		/* WX^P(RENV1) */
		dwRet = hcp52c_wReg(hDevID, axis, 0x9c, dwData);
	}
	return dwRet;
}

/************************************************************************/
/* GR[_Z̐ݒ 													*/
/* 		FfoCXnhCC_AŎgpy񐔁Cɐ 	*/
/************************************************************************/
DWORD hcp52c_SetEz(DWORD hDevID, WORD axis, WORD count, WORD pol)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;

	/* _AŎgpZ */
	count &= 0x000f;

	/* WX^3(RENV3)Ǎ */
	dwRet = hcp52c_rReg(hDevID, axis, 0xde, &dwData);
	if(dwRet)								return dwRet;

	dwData &= 0xffffff0f;
	dwData |= count << 4;
	/* WX^3(RENV3) */
	dwRet = hcp52c_wReg(hDevID, axis, 0x9e, dwData);	
	if(dwRet)								return dwRet;

	/* ɐI */
	/* WX^Q(RENV2)Ǎ */
	dwRet = hcp52c_rReg(hDevID, axis, 0xdd, &dwData);
	if(dwRet)								return dwRet;

	if(pol) dwData |= (DWORD) 0x800000;	/*  */
	else	dwData &= (DWORD)~0x800000;	/* オ */

	/* WX^2(RENV2) */
	dwRet = hcp52c_wReg(hDevID, axis, 0x9d, dwData);
	return dwRet;
}

/********************************************************/
/* T[{G[JE^NAo͂̐ݒ 				*/
/* 		FfoCXnhCCgp@			*/
/********************************************************/
DWORD hcp52c_SetSvCtrCl(DWORD hDevID, WORD axis, WORD enable)
{
	DWORD	dwData;
	DWORD	dwRet;			/* ߂l */

	/* ԍ0`11ȊO܂ */
	/* gp@0`3ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return 0x100;
	if((enable < 0) || (enable > 3))		return 0x100;

	/* WX^P(RENV1)Ǎ */
	dwRet = hcp52c_rReg(hDevID, axis, 0xdc, &dwData);
	if(dwRet)								return dwRet;

	dwData &= (DWORD)~0xC00;
	switch(enable) {
		case 0:								break;	/* sgp */
		case 1:	dwData |= (DWORD) 0x800;	break;	/* _A */
		case 2:	dwData |= (DWORD) 0x400;	break;	/* ُ~ */
		case 3:	dwData |= (DWORD) 0xC00;	break;	/* _Ayшُ~ */
	}
	/* WX^P(RENV1) */
	dwRet = hcp52c_wReg(hDevID, axis, 0x9c, dwData);
	return dwRet;
}

/************************************************************/
/* w߃pX̏o͌`̐ݒ 								*/
/* 		FfoCXnhCC						*/
/*				w߃pX̏o͌`(ʃpX/ʃpX) */
/************************************************************/
DWORD hcp52c_SetCmdPulse(DWORD hDevID, WORD axis, WORD cmdpls)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO ܂ */
	/* w߃pX̏o͌`0`3ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))		return ILLEGAL_PRM;
	if((cmdpls < 0) || (cmdpls > 3))			return ILLEGAL_PRM;

	/* WX^P(RENV1)Ǎ */
	dwRet = hcp52c_rReg(hDevID, axis, 0xdc, &dwData);
	if(dwRet)									return dwRet;

	dwData &= (DWORD)~0x7;
	switch(cmdpls) {
		case 0:	dwData |= (DWORD)0x04;			break;	/*  */
		case 1:	dwData |= (DWORD)0x02;			break;	/*  */
		case 2:	dwData |= (DWORD)0x07;			break;
		case 3:	dwData |= (DWORD)0x00;			break;
	}

	/* WX^P(RENV1) */
	dwRet = hcp52c_wReg(hDevID, axis, 0x9c, dwData);
	return dwRet;
}

/************************************************************/
/* `ݒ 											*/
/* 		FfoCXnhCC`(/S)	*/
/************************************************************/
DWORD hcp52c_SetAccProfile(DWORD hDevID, WORD axis, WORD accpro)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;

	/* 샂[h(RMD)Ǎ */
	dwRet = hcp52c_rReg(hDevID, axis, 0xd7, &dwData);
	if(dwRet)								return dwRet;

	if(accpro)	dwData |= (DWORD) 0x400;	/* S */
	else		dwData &= (DWORD)~0x400;	/*  */

	/* 샂[h(PRMD) */
	dwRet = hcp52c_wReg(hDevID, axis, 0x87, dwData);
	return dwRet;
}

/************************************************************************/
/* _̐ݒ 													*/
/* 		FfoCXnhCC_̐ݒ(/}jA)	*/
/************************************************************************/
DWORD hcp52c_SetAutoDec(DWORD hDevID, WORD axis, WORD para)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;

	/* 샂[h(RMD)Ǎ */
	dwRet = hcp52c_rReg(hDevID, axis, 0xd7, &dwData);
	if(dwRet)								return dwRet;

	if(para)	dwData |= (DWORD) 0x2000;	/* }jA */
	else		dwData &= (DWORD)~0x2000;	/*  */

	/* 샂[h(PRMD) */
	dwRet = hcp52c_wReg(hDevID, axis, 0x87, dwData);
	return dwRet;
}


/*===============================================================*/
/*							Ǎ݌n̊֐						 */
/*===============================================================*/
/********************************************************/
/* CXe[^XǍ 								*/
/* 		FfoCXnhCCCXe[^X 	*/
/********************************************************/
DWORD hcp52c_ReadMainSts(DWORD hDevID, WORD axis, WORD* msts)
{
	WORD	wData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;

	/* CXe[^XǍ */
	dwRet = cp52c_rMstsW(hDevID, axis, &wData);
	if(dwRet)								return dwRet;

	*msts = wData;
	return 0;
}

/************************************************************/
/* G[Xe[^XǍ 									*/
/* 		FfoCXnhCCG[Xe[^X		*/
/************************************************************/
DWORD hcp52c_ReadErrorSts(DWORD hDevID, WORD axis, DWORD* ests)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;

	/* G[Xe[^XǍ */
	dwRet = hcp52c_rReg(hDevID, axis, 0xf2, &dwData);
	if(dwRet)								return dwRet;

	*ests = dwData;
	return 0;
}

/************************************************************/
/* CxgXe[^XǍ 								*/
/* 		FfoCXnhCCCxgXe[^X		*/
/************************************************************/
DWORD hcp52c_ReadEventSts(DWORD hDevID, WORD axis, DWORD* ists)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;

	/* CxgXe[^XǍ */
	dwRet = hcp52c_rReg(hDevID, axis, 0xf3, &dwData);
	if(dwRet)								return dwRet;

	*ists = dwData;
	return 0;
}

/********************************************************/
/* TuXe[^XǍ 								*/
/* 		FfoCXnhCCTuXe[^X 		*/
/********************************************************/
DWORD hcp52c_ReadSubSts(DWORD hDevID, WORD axis, WORD* ssts)
{
	WORD	wData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;

	/* TuXe[^XǍ */
	dwRet = cp52c_rSstsW(hDevID, axis, &wData);
	if(dwRet)								return dwRet;

	*ssts = wData;
	return 0;
}

/********************************************************/
/* gXe[^XǍ 								*/
/* 		FfoCXnhCCgXe[^X 		*/
/********************************************************/
DWORD hcp52c_ReadExSts(DWORD hDevID, WORD axis, DWORD* exsts)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;

	/* gXe[^XǍ */
	dwRet = hcp52c_rReg(hDevID, axis, 0xf1, &dwData);
	if(dwRet)								return dwRet;

	*exsts = dwData;
	return 0;
}

/********************************************/
/* xǍ 								*/
/* 		FfoCXnhCCx 	*/
/********************************************/
DWORD hcp52c_ReadSpd(DWORD hDevID, WORD axis, WORD* spd)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;

	/* xǍ */
	dwRet = hcp52c_rReg(hDevID, axis, 0xf5, &dwData);
	if(dwRet)								return dwRet;

	dwData &= (DWORD)0x0000ffff;
	*spd = (WORD)dwData;
	return 0;
}

/****************************************************************/
/* JE^Ǎ 												*/
/* 		FfoCXnhCCǍJE^CJE^l	*/
/****************************************************************/
DWORD hcp52c_ReadCtr(DWORD hDevID, WORD axis, WORD selctr, long* count)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO܂ */
	/* ǍJE^1`4ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))		return ILLEGAL_PRM;
	if((selctr < 1) || (selctr > 4))			return ILLEGAL_PRM;

	/* JE^Ǎ */
	dwRet = hcp52c_rReg(hDevID, axis, (BYTE)(0xe2 + selctr), &dwData);
	if(dwRet)									return dwRet;

	*count = dwData;
	return 0;
}

/*===============================================================*/
/*							ݒn̊֐					 */
/*===============================================================*/
/************************************************************/
/* Cxg}XN̐ݒ 									*/
/* 		FfoCXnhCCCxg}XNf[^	*/
/************************************************************/
DWORD hcp52c_SetEventMask(DWORD hDevID, WORD axis, DWORD mask)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO܂ */
	/* Cxg}XNf[^ 0`0x0003ffffȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;
	if(mask & 0xfffc0000)					return ILLEGAL_PRM;

	/* Cxg}XN(RIRQ)WX^̏ */
	dwRet = hcp52c_wReg(hDevID, axis, 0xac, mask);
	return dwRet;
}

/********************************************************/
/* x[Xx̐ݒ 									*/
/* 		FfoCXnhCCx[XxWX^	*/
/********************************************************/
DWORD hcp52c_SetFLSpd(DWORD hDevID, WORD axis, DWORD spd)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO܂ */
	/* xWX^1`0xffffȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;
	if((!spd) || (spd > 0xffff))			return ILLEGAL_PRM;

	/* PRFL̏ */
	dwRet = hcp52c_wReg(hDevID, axis, 0x81, spd);
	return dwRet;
}

/********************************************************/
/* ⏕x̐ݒ 										*/
/* 		FfoCXnhCC⏕xWX^	*/
/********************************************************/
DWORD hcp52c_SetAuxSpd(DWORD hDevID, WORD axis, DWORD spd)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO܂ */
	/* xWX^1`0xffffȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;
	if((!spd) || (spd > 0xffff))			return ILLEGAL_PRM;

	/* RFȀ */
	dwRet = hcp52c_wReg(hDevID, axis, 0x9b, spd);
	return dwRet;
}

/********************************************************************************/
/* [g̐ݒ 															*/
/* 		FfoCXnhCC[g 									*/
/* 			NbNg = 19660800Hz 									*/
/* 			(b) = (PRFH - PRFL) * (PRUR + 1) * 4 / 19660800	*/
/* 			r(b) = (PRFH - PRFL) * (PRUR + 1) * 8 / 19660800	*/
/********************************************************************************/
DWORD hcp52c_SetAccRate(DWORD hDevID, WORD axis, DWORD rate)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO܂ */
	/* [g1`0xffffȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;
	if((!rate) || (rate > 0xffff))			return ILLEGAL_PRM;

	/* PRUȐ */
	dwRet = hcp52c_wReg(hDevID, axis, 0x83, rate);
	return dwRet;
}

/********************************************************/
/* [g̐ݒ 									*/
/* 		FfoCXnhCC[g			*/
/********************************************************/
DWORD hcp52c_SetDecRate(DWORD hDevID, WORD axis, DWORD rate)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;
	if(rate > 0xffff)						return ILLEGAL_PRM;

	/* PRDȐ */
	dwRet = hcp52c_wReg(hDevID, axis, 0x84, rate);
	return dwRet;
}

/********************************************************/
/* {ݒl(MG)̐ݒ 								*/
/* 		FfoCXnhCC{ݒl(MG)		*/
/* 			MG = 300 / { - 1 						*/
/********************************************************/
DWORD hcp52c_SetMult(DWORD hDevID, WORD axis, DWORD rmg)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO܂ */
	/* {ݒl1ȉ͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;
	if(rmg < 2)								return ILLEGAL_PRM;

	/* PRMG̏ */
	dwRet = hcp52c_wReg(hDevID, axis, 0x85, rmg);
	return dwRet;
}

/************************************************/
/* _̐ݒ 								*/
/* 		FfoCXnhCC_		*/
/************************************************/
DWORD hcp52c_SetDecPoint(DWORD hDevID, WORD axis, long dstnc)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;

	/* PRDP̏ */
	dwRet = hcp52c_wReg(hDevID, axis, 0x86, dstnc);
	return dwRet;
}

/*==============================================================*/
/*							^pݒn̊֐					*/
/*==============================================================*/
/****************************************************/
/* 샂[h 								*/
/* 		FfoCXnhCC샂[h		*/
/****************************************************/
DWORD hcp52c_WritOpeMode(DWORD hDevID, WORD axis, WORD mode)
{
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO܂ */
	/* 샂[hُ͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;
	if(mode & 0xff80)						return ILLEGAL_PRM;
	if(!mod_tbl[mode])						return ILLEGAL_PRM;

	/* 샂[h(PRMD)Ǎ */
	dwRet = hcp52c_rReg(hDevID, axis, 0xc7, &dwData);
	if(dwRet)								return dwRet;

	dwData &= 0xef3a700;
	if(mode == 0x42)	dwData |= 0x4041;
	else				dwData |= mode;	

	/* 샂[h(PRMD) */
	dwRet = hcp52c_wReg(hDevID, axis, 0x87, dwData);
	return dwRet;
}

/********************************************************/
/* 쑬xWX^̐ݒ 								*/
/* 		FfoCXnhCC쑬xWX^	*/
/********************************************************/
DWORD hcp52c_WritFHSpd(DWORD hDevID, WORD axis, DWORD spd)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO܂ */
	/* xWX^1`0xffffȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))	return ILLEGAL_PRM;
	if((!spd) || (spd > 0xffff))			return ILLEGAL_PRM;

	/* PRFH̏ */
	dwRet = hcp52c_wReg(hDevID, axis, 0x82, spd);
	return dwRet;
}

/************************************************/
/* ʒu߈ړʂ̐ݒ 						*/
/* 		FfoCXnhCCړ		*/
/************************************************/
DWORD hcp52c_WritPos(DWORD hDevID, WORD axis, long dstnc)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))			return ILLEGAL_PRM;

	/* ړʂ̃`FbN */
	if((dstnc < -134217728) || (134217727 < dstnc))	return ILLEGAL_PRM;

	/* PRMV̏ */
	dwRet = hcp52c_wReg(hDevID, axis, 0x80, dstnc);
	return dwRet;
}

/************************************************/
/* Ԃ̈ړʂ̐ݒ 						*/
/* 		FfoCXnhCCړ		*/
/************************************************/
DWORD hcp52c_WritLine(DWORD hDevID, WORD axis, long dstnc)
{
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO͈̎G[ */
	if((axis < X1_AX) || (U3_AX < axis))			return ILLEGAL_PRM;

	/* ړʂ̃`FbN */
	if((dstnc < -134217728) || (134217727 < dstnc))	return ILLEGAL_PRM;

	/* PRMV̏ */
	dwRet = hcp52c_wReg(hDevID, axis, 0x80, dstnc);
	return dwRet;
}

/************************************************************/
/* ~ʕԂ̃f[^ݒ 									*/
/* 		FfoCXnhCgݍ킹CI_ʒu1,	*/
/*				I_ʒu2CSʒu1CSʒu2				*/
/************************************************************/
DWORD hcp52c_WritCircl(DWORD hDevID, WORD axis,
						long dstnc1, long dstnc2, long center1,long center2)
{
	DWORD	dwRet; 				/* ߂l */
	WORD	ax1,ax2;

	/* Ԏ̑gݍ킹̈0`17ȊO̎̓G[ */
	if((axis < X1_AX) || (17 < axis))	return ILLEGAL_PRM;
	if((dstnc1 < -134217728)  || (134217727 < dstnc1))	return ILLEGAL_PRM;
	if((dstnc2 < -134217728)  || (134217727 < dstnc2))	return ILLEGAL_PRM;
	if((center1 < -134217728) || (134217727 < center1))	return ILLEGAL_PRM;
	if((center2 < -134217728) || (134217727 < center2))	return ILLEGAL_PRM;

	switch(axis) {
		case  0:	ax1 = 0;	ax2 = 1;	break;	/* X1(0),  Y1(1) */
		case  1:	ax1 = 0;	ax2 = 2;	break;	/* X1(0),  Z1(2) */
		case  2:	ax1 = 0;	ax2 = 3;	break;	/* X1(0),  U1(3) */
		case  3:	ax1 = 1;	ax2 = 2;	break;	/* Y1(1),  Z1(2) */
		case  4:	ax1 = 1;	ax2 = 3;	break;	/* Y1(1),  U1(3) */
		case  5:	ax1 = 2;	ax2 = 3;	break;	/* Z1(2),  U1(3) */
		case  6:	ax1 = 4;	ax2 = 5;	break;	/* X2(4),  Y2(5) */
		case  7:	ax1 = 4;	ax2 = 6;	break;	/* X2(4),  Z2(6) */
		case  8:	ax1 = 4;	ax2 = 7;	break;	/* X2(4).  U2(7) */
		case  9:	ax1 = 5;	ax2 = 6;	break;	/* Y2(5),  Z2(6) */
		case 10:	ax1 = 5;	ax2 = 7;	break;	/* Y2(5),  U2(7) */
		case 11:	ax1 = 6;	ax2 = 7;	break;	/* Z2(6),  U2(7) */
		case 12:	ax1 = 8;	ax2 = 9;	break;	/* X3(8),  Y3(9) */
		case 13:	ax1 = 8;	ax2 =10;	break;	/* X3(8),  Z3(10) */
		case 14:	ax1 = 8;	ax2 =11;	break;	/* X3(8).  U3(11) */
		case 15:	ax1 = 9;	ax2 =10;	break;	/* Y3(9),  Z3(10) */
		case 16:	ax1 = 9;	ax2 =11;	break;	/* Y3(9),  U3(11) */
		case 17:	ax1 =10;	ax2 =11;	break;	/* Z3(10), U3(11) */
	}
	/* PRMV(I_ʒu)̏ */
	dwRet = hcp52c_wReg(hDevID, ax1, 0x80, dstnc1);
	if(dwRet)						return dwRet;	/* X1,X1,X1,Y1,Y1,Z1,X2,X2,X2,Y2,Y2,Z2,X3,X3,X3,Y3,Y3,Z3 */
	dwRet = hcp52c_wReg(hDevID, ax2, 0x80, dstnc2);	/* Y1,Z1,U1,Z1,U1,U1,Y2,Z2,U2,Z2,U2,U2,Y3,Z3,U3,Z3,U3,U3 */
	if(dwRet)						return dwRet;
	/* PRIP(Sʒu)̏ */
	dwRet = hcp52c_wReg(hDevID, ax1, 0x88, center1);
	if(dwRet)						return dwRet;	/* X1,X1,X1,Y1,Y1,Z1,X2,X2,X2,Y2,Y2,Z2,X3,X3,X3,Y3,Y3,Z3 */
	dwRet = hcp52c_wReg(hDevID, ax2, 0x88, center2);	/* Y1,Z1,U1,Z1,U1,U1,Y2,Z2,U2,Z2,U2,U2,Y3,Z3,U3,Z1,U1,U1 */
	return dwRet;
}

/****************************************************************/
/* JE^vZbg 											*/
/* 		FfoCXnhC vZbglCJE^I	*/
/****************************************************************/
DWORD hcp52c_WritCtr(DWORD hDevID, WORD axis, long preset, WORD selctr)
{
	BYTE	byCmd;
	DWORD	dwRet;				/* ߂l */

	/* ԍ0`11ȊO܂̓JE^1`4ȊO̎̓G[ */
	if((axis < X1_AX) || (U3_AX < axis))				return ILLEGAL_PRM;
	if((selctr < 1) || (4<selctr))						return ILLEGAL_PRM;
	/* vZbgl̃`FbN */
	if((preset < -134217728) || (134217727 < preset))	return ILLEGAL_PRM;

	/* vZbgl */
	byCmd = (BYTE)(0xa2 + selctr);	/* JE^I */
	dwRet = hcp52c_wReg(hDevID, axis, byCmd, preset);
	return dwRet;
}

/*==============================================================*/
/*							쐧n̊֐					*/
/*==============================================================*/
/****************************************************/
/* ~ 										*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hcp52c_DecStop(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				/* ߂l */

	/* ԍ0x01`0x0fffȊO̎̓G[ */
	if((axis <= 0) || (0x0fff < axis))	return ILLEGAL_PRM;

	/* X1 - U1 : wPɌ~ */
	if(axis & 0x000f)
		dwRet = cp52c_wCmdW(hDevID, 0, (WORD)(((axis & 0x000f) << 8) | 0x4a));
	/* X2 - U2 : wQɌ~ */
	if( (axis & 0x00f0) && (!dwRet) )
		dwRet = cp52c_wCmdW(hDevID, 4, (WORD)(((axis & 0x00f0) << 4) | 0x4a));
	/* X3 - U3 : wRɌ~ */
	if( (axis & 0x0f00) && (!dwRet) )
		dwRet = cp52c_wCmdW(hDevID, 8, (WORD)((axis & 0x0f00) | 0x4a));
	return dwRet;
}

/****************************************************/
/* ~ 											*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hcp52c_QuickStop(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				/* ߂l */

	/* ԍ0x01`0x0fffȊO̎̓G[ */
	if((axis <= 0) || (0x0fff < axis))	return ILLEGAL_PRM;

	/* X1 - U1 : wPɑ~ */
	if(axis & 0x000f)
		dwRet = cp52c_wCmdW(hDevID, 0, (WORD)(((axis & 0x000f) << 8) | 0x49));
	/* X2 - U2 : wQɑ~ */
	if( (axis & 0x00f0) && (!dwRet) )
		dwRet = cp52c_wCmdW(hDevID, 4, (WORD)(((axis & 0x00f0) << 4) | 0x49));
	/* X3 - U3 : wRɑ~ */
	if( (axis & 0x0f00) && (!dwRet) )
		dwRet = cp52c_wCmdW(hDevID, 8, (WORD)((axis & 0x0f00) | 0x49));
	return dwRet;
}

/****************************************************/
/* ~ 										*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hcp52c_EmgStop(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				/* ߂l */

	/* ԍ0x01`0x0fffȊO̎̓G[ */
	if((axis <= 0) || (0x0fff < axis))	return ILLEGAL_PRM;

	/* X1 - U1 : wPɔ~ */
	if(axis & 0x000f)
		dwRet = cp52c_wCmdW(hDevID, 0, (WORD)(((axis & 0x000f) << 8) | 0x05));
	/* X2 - U2 : wQɔ~ */
	if( (axis & 0x00f0) && (!dwRet) )
		dwRet = cp52c_wCmdW(hDevID, 4, (WORD)(((axis & 0x00f0) << 4) | 0x05));
	/* X3 - U3 : wRɔ~ */
	if( (axis & 0x0f00) && (!dwRet) )
		dwRet = cp52c_wCmdW(hDevID, 8, (WORD)((axis & 0x0f00) | 0x05));
	return dwRet;
}

/****************************************************/
/* ~ 										*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hcp52c_SyDecStop(DWORD hDevID, WORD axis)
{
	WORD	wAx;
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */
	WORD	axbit[12] = { 0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x100,0x200,0x400,0x800 };

	/* ԍ0x01`0x0fffȊO̎̓G[ */
	if((axis <= 0) || (0x0fff < axis))		return ILLEGAL_PRM;

	for( wAx=0; wAx<12; wAx++ ) {
		if(axis & axbit[wAx]) {
		/* ~:wߎ */
			/* WX^P(RENV1): ~ */
			dwRet = hcp52c_rReg(hDevID, wAx, 0xdc, &dwData);
			if(dwRet)						return dwRet;
			dwData |= (DWORD) 0x00080000;	/* ~ */
			dwRet = hcp52c_wReg(hDevID, wAx, 0x9c, dwData);
			if(dwRet)						return dwRet;
			/* 샂[h(RMD): ~ */
			dwRet = hcp52c_rReg(hDevID, wAx, 0xd7, &dwData);
			if(dwRet)						return dwRet;
			dwData |= 0x01000000;
			dwRet = hcp52c_wReg(hDevID, wAx, 0x97, dwData);
			if(dwRet)						return dwRet;
		} else {
		/* ~:wߎ */
			/* 샂[h(RMD): ~ݾ */
			dwRet = hcp52c_rReg(hDevID, wAx, 0xd7, &dwData);
			if(dwRet)						return dwRet;
			dwData &= (~0x01000000);
			dwRet = hcp52c_wReg(hDevID, wAx, 0x97, dwData);
			if(dwRet)						return dwRet;
		}
	}
	dwRet = cp52c_wCmdW(hDevID, 0, 0x07);	/* X1FR}h */
	
	/* 샂[h(RMD): ~ݾ */
	for(wAx = 0; wAx < 12; wAx++) {
		if(axis & axbit[wAx]) {
			dwRet = hcp52c_rReg(hDevID, wAx, 0xd7, &dwData);
			if(dwRet)						return dwRet;
			dwData &= (~0x01000000);
			dwRet = hcp52c_wReg(hDevID, wAx, 0x87, dwData);
			if(dwRet)						return dwRet;
		}
	}
	return dwRet;
}

/****************************************************/
/* ~ 											*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hcp52c_SyQuickStop(DWORD hDevID, WORD axis)
{
	WORD	wAx;
	DWORD	dwData;
	DWORD	dwRet;				/* ߂l */
	WORD	axbit[12] = { 0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x100,0x200,0x400,0x800 };

	/* ԍ0x01`0x0fffȊO̎̓G[ */
	if((axis <= 0) || (0x0fff < axis))		return ILLEGAL_PRM;

	for(wAx=0; wAx<12; wAx++) {
		if(axis & axbit[wAx]) {
		/* ~:wߎ */
			/* WX^P(RENV1): ~ */
			dwRet = hcp52c_rReg(hDevID, wAx, 0xdc, &dwData);
			if(dwRet)						return dwRet;
			dwData &= (DWORD)(~0x00080000);		/* ~ */
			dwRet = hcp52c_wReg(hDevID, wAx, 0x9c, dwData);
			if(dwRet)						return dwRet;

			/* 샂[h(RMD): ~ */
			dwRet = hcp52c_rReg(hDevID, wAx, 0xd7, &dwData);
			if(dwRet)						return dwRet;
			dwData |= 0x01000000;				/* ~ */
			dwRet = hcp52c_wReg(hDevID, wAx, 0x97, dwData);
			if(dwRet)						return dwRet;
		} else {
		/* ~:wߎ */
			/* 샂[h(RMD): ~ݾ */
			dwRet = hcp52c_rReg(hDevID, wAx, 0xd7, &dwData);
			if(dwRet)						return dwRet;
			dwData &= (~0x01000000);
			dwRet = hcp52c_wReg(hDevID, wAx, 0x97, dwData);
			if(dwRet)						return dwRet;
		}
	}
	dwRet = cp52c_wCmdW(hDevID, 0, 0x07);	/* X1FR}h */

	/* 샂[h(PRMD): ~ݾ */
	for(wAx = 0; wAx < 12; wAx++) {
		if(axis & axbit[wAx]) {
			dwRet = hcp52c_rReg(hDevID, wAx, 0xd7, &dwData);
			if(dwRet)						return dwRet;
			dwData &= (~0x01000000);
			dwRet = hcp52c_wReg(hDevID, wAx, 0x87, dwData);
			if(dwRet)						return dwRet;
		}
	}
	return dwRet;
}

/****************************************************/
/* X^[g 									*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hcp52c_AccStart(DWORD hDevID, WORD axis)
{
	WORD	wCmd;
	WORD	wAx;
	DWORD	dwRet;				/* ߂l */
	DWORD	dwData;
	DWORD	dwRmd[12] = { 0 };
	WORD	axbit[12] = { 0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x100,0x200,0x400,0x800 };

	/* ԍ0x01`0x0fffȊO̎̓G[ */
	if((axis <= 0) || (0x0fff < axis))		return ILLEGAL_PRM;

	if(!(axis & 0xff0)) {			/* X1-U1̂ */
 		wCmd = (axis << 8) | 0x53;
		dwRet = cp52c_wCmdW(hDevID, 0, wCmd);		/* X1R}h */
	} else if(!(axis & 0xf0f)) {	/* X2-U2̂ */
 		wCmd = (axis << 4) | 0x53;
		dwRet = cp52c_wCmdW(hDevID, 4, wCmd);		/* X2R}h */
	} else if(!(axis & 0x0ff)) {	/* X3-U3̂ */
 		wCmd = axis | 0x53;
		dwRet = cp52c_wCmdW(hDevID, 8, wCmd);		/* X3R}h */
	} else {	/* X1-U1܂X2-U2܂X3-U3ɂ܂ꍇ */
		for(wAx = 0; wAx < 12; wAx++) {
			if(axis & axbit[wAx]) {
			/* :wߎ */
				/* 샂[h(RMD):  */
				dwRet = hcp52c_rReg(hDevID, wAx, 0xd7, &dwRmd[wAx]);
				if(dwRet)					return dwRet;
				dwData = dwRmd[wAx] | 0x00040000;
				dwRet = hcp52c_wReg(hDevID, wAx, 0x97, dwData);
				if(dwRet)					return dwRet;
				dwRet = cp52c_wCmdW(hDevID, wAx, 0x53);		/* ĺޏ */
			} else {
			/* :wߎ */
				/* 샂[h(RMD): (񓯎) */
				dwRet = hcp52c_rReg(hDevID, wAx, 0xd7, &dwRmd[wAx]);
				if(dwRet)					return dwRet;
				dwData = dwRmd[wAx] & (~0x000c0000);
				dwRet = hcp52c_wReg(hDevID, wAx, 0x97, dwData);
				if(dwRet)					return dwRet;
			}
		}
		dwRet = cp52c_wCmdW(hDevID, 0, 0x06);	/* X1:STAMo */
		
		// 샂[hɖ߂
		for(wAx = 0; wAx < 12; wAx++) {
			if(axis & axbit[wAx]) {
				/* 샂[h(PRMD) */
				dwRet = hcp52c_wReg(hDevID, wAx, 0x87, dwRmd[wAx]);
				if(dwRet)					return dwRet;
			}
		}
	}
	return dwRet;
}

/****************************************************/
/* FH葬X^[g 									*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hcp52c_CnstStartFH(DWORD hDevID, WORD axis)
{
	WORD	wCmd;
	WORD	wAx;
	DWORD	dwRet;				/* ߂l */
	DWORD	dwData;
	DWORD	dwRmd[12] = { 0 };
	WORD	axbit[12] = { 0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x100,0x200,0x400,0x800 };

	/* ԍ0x01`0x0fffȊO̎̓G[ */
	if((axis <= 0) || (0x0fff < axis))	return ILLEGAL_PRM;

	if(!(axis & 0xff0)) {			/* X1-U1̂ */
 		wCmd = (axis << 8) | 0x51;
		dwRet = cp52c_wCmdW(hDevID, 0, wCmd);		/* X1R}h */
	} else if(!(axis & 0xf0f)) {	/* X2-U2̂ */
 		wCmd = (axis << 4) | 0x51;
		dwRet = cp52c_wCmdW(hDevID, 4, wCmd);		/* X2R}h */
	} else if(!(axis & 0x0ff)) {	/* X3-U3̂ */
 		wCmd = axis | 0x51;
		dwRet = cp52c_wCmdW(hDevID, 8, wCmd);		/* X3R}h */
	} else {	/* X1-U1܂X2-U2܂X3-U3ɂ܂ꍇ */
		for(wAx = 0; wAx < 12; wAx++) {
			if(axis & axbit[wAx]) {
			/* FH葬:wߎ */
				/* 샂[h(RMD):  */
				dwRet = hcp52c_rReg(hDevID, wAx, 0xd7, &dwRmd[wAx]);
				if(dwRet)				return dwRet;
				dwData = dwRmd[wAx] | 0x00040000;
				dwRet = hcp52c_wReg(hDevID, wAx, 0x97, dwData);
				if(dwRet)				return dwRet;
				dwRet = cp52c_wCmdW(hDevID, wAx, 0x51);		/* ĺޏ */
			} else {
			/* :wߎ */
				/* 샂[h(RMD): (񓯎) */
				dwRet = hcp52c_rReg(hDevID, wAx, 0xd7, &dwRmd[wAx]);
				if(dwRet)				return dwRet;
				dwData = dwRmd[wAx] & (~0x000c0000);
				dwRet = hcp52c_wReg(hDevID, wAx, 0x97, dwData);
				if(dwRet)				return dwRet;
			}
		}
		dwRet = cp52c_wCmdW(hDevID, 0, 0x06);	/* X1:STAMo */
		
		// 샂[hɖ߂
		for(wAx = 0; wAx < 12; wAx++) {
			if(axis & axbit[wAx]) {
				/* 샂[h(PRMD) */
				dwRet = hcp52c_wReg(hDevID, wAx, 0x87, dwRmd[wAx]);
				if(dwRet)				return dwRet;
			}
		}
	}
	return dwRet;
}

/****************************************************/
/* FL葬X^[g 									*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hcp52c_CnstStartFL(DWORD hDevID, WORD axis)
{
	WORD	wCmd;
	WORD	wAx;
	DWORD	dwRet;				/* ߂l */
	DWORD	dwData;
	DWORD	dwRmd[12] = { 0 };
	WORD	axbit[12] = { 0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x100,0x200,0x400,0x800 };

	/* ԍ0x01`0x0fffȊO̎̓G[ */
	if((axis <= 0) || (0x0fff < axis))	return ILLEGAL_PRM;

	if(!(axis & 0xff0)) {			/* X1-U1̂ */
 		wCmd = (axis << 8) | 0x50;
		dwRet = cp52c_wCmdW(hDevID, 0, wCmd);		/* X1R}h */
	} else if(!(axis & 0xf0f)) {	/* X2-U2̂ */
 		wCmd = (axis << 4) | 0x50;
		dwRet = cp52c_wCmdW(hDevID, 4, wCmd);		/* X2R}h */
	} else if(!(axis & 0x0ff)) {	/* X3-U3̂ */
 		wCmd = axis | 0x50;
		dwRet = cp52c_wCmdW(hDevID, 8, wCmd);		/* X3R}h */
	} else {	/* X1-U1܂X2-U2܂X3-U3ɂ܂ꍇ */
		for(wAx = 0; wAx < 12; wAx++) {
			if(axis & axbit[wAx]) {
			/* FL葬:wߎ */
				/* 샂[h(RMD):  */
				dwRet = hcp52c_rReg(hDevID, wAx, 0xd7, &dwRmd[wAx]);
				if(dwRet)				return dwRet;
				dwData = dwRmd[wAx] | 0x00040000;
				dwRet = hcp52c_wReg(hDevID, wAx, 0x97, dwData);
				if(dwRet)				return dwRet;
				dwRet = cp52c_wCmdW(hDevID, wAx, 0x50);		/* ĺޏ */
			} else {
			/* :wߎ */
				/* 샂[h(RMD): (񓯎) */
				dwRet = hcp52c_rReg(hDevID, wAx, 0xd7, &dwRmd[wAx]);
				if(dwRet)				return dwRet;
				dwData = dwRmd[wAx] & (~0x000c0000);
				dwRet = hcp52c_wReg(hDevID, wAx, 0x97, dwData);
				if(dwRet)				return dwRet;
			}
		}
		dwRet = cp52c_wCmdW(hDevID, 0, 0x06);	/* X1:STAMo */
		
		// 샂[hɖ߂
		for(wAx = 0; wAx < 12; wAx++) {
			if(axis & axbit[wAx]) {
				/* 샂[h(PRMD) */
				dwRet = hcp52c_wReg(hDevID, wAx, 0x87, dwRmd[wAx]);
				if(dwRet)				return dwRet;
			}
		}
	}
	return dwRet;
}

/****************************************************/
/* FH葬X^[g㌸~ 						*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hcp52c_CnstStartByDec(DWORD hDevID, WORD axis)
{
	WORD	wCmd;
	WORD	wAx;
	DWORD	dwRet;				/* ߂l */
	DWORD	dwData;
	DWORD	dwRmd[12] = { 0 };
	WORD	axbit[12] = { 0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80,0x100,0x200,0x400,0x800 };

	/* ԍ0x01`0x0fffȊO̎̓G[ */
	if((axis <= 0) || (0x0fff < axis))	return ILLEGAL_PRM;

	if(!(axis & 0xff0)) {			/* X1-U1̂ */
 		wCmd = (axis << 8) | 0x52;
		dwRet = cp52c_wCmdW(hDevID, 0, wCmd);		/* X1R}h */
	} else if(!(axis & 0xf0f)) {	/* X2-U2̂ */
 		wCmd = (axis << 4) | 0x52;
		dwRet = cp52c_wCmdW(hDevID, 4, wCmd);		/* X2R}h */
	} else if(!(axis & 0x0ff)) {	/* X3-U3̂ */
 		wCmd = axis | 0x52;
		dwRet = cp52c_wCmdW(hDevID, 8, wCmd);		/* X3R}h */
	} else {	/* X1-U1܂X2-U2܂X3-U3ɂ܂ꍇ */
		for(wAx = 0; wAx < 12; wAx++) {
			if(axis & axbit[wAx]) {
			/* FH葬Č㌸~:wߎ */
				/* 샂[h(RMD):  */
				dwRet = hcp52c_rReg(hDevID, wAx, 0xd7, &dwRmd[wAx]);
				if(dwRet)				return dwRet;
				dwData = dwRmd[wAx] | 0x00040000;
				dwRet = hcp52c_wReg(hDevID, wAx, 0x97, dwData);
				if(dwRet)				return dwRet;
				dwRet = cp52c_wCmdW(hDevID, wAx, 0x52);		/* ĺޏ */
			} else {
			/* :wߎ */
				/* 샂[h(RMD): (񓯎) */
				dwRet = hcp52c_rReg(hDevID, wAx, 0xd7, &dwRmd[wAx]);
				if(dwRet)				return dwRet;
				dwData = dwRmd[wAx] & (~0x000c0000);
				dwRet = hcp52c_wReg(hDevID, wAx, 0x97, dwData);
				if(dwRet)				return dwRet;
			}
		}
		dwRet = cp52c_wCmdW(hDevID, 0, 0x06);	/* X1:STAMo */
		
		// 샂[hɖ߂
		for(wAx = 0; wAx < 12; wAx++) {
			if(axis & axbit[wAx]) {
				/* 샂[h(PRMD) */
				dwRet = hcp52c_wReg(hDevID, wAx, 0x87, dwRmd[wAx]);
				if(dwRet)				return dwRet;
			}
		}
	}
	return dwRet;
}

/****************************************************/
/* T[{I 										*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hcp52c_SvOn(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				/* ߂l */

	/* ԍ0x01`0x0fȊO̎̓G[ */
	if((axis <= 0) || (0x0f < axis))	return ILLEGAL_PRM;

	/* X1 - U1 : wPɃT[{nm */
	dwRet = cp52c_wCmdW(hDevID, 0, (WORD)(((axis & 0x000f) << 8) | 0x18));
	return dwRet;
}

/****************************************************/
/* T[{It 										*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hcp52c_SvOff(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				/* ߂l */

	/* ԍ0x01`0x0fȊO̎̓G[ */
	if((axis <= 0) || (0x0f < axis))	return ILLEGAL_PRM;

	/* X1 - U1 : wPɃT[{nee */
	dwRet = cp52c_wCmdW(hDevID, 0, (WORD)(((axis & 0x000f) << 8) | 0x10));
	return dwRet;
}

/****************************************************/
/* T[{ZbgI 								*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hcp52c_SvResetOn(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				/* ߂l */

	/* ԍ0x01`0x0fȊO̎̓G[ */
	if((axis <= 0) || (0x0f < axis))	return ILLEGAL_PRM;

	/* X1 - U1 : wPɃT[{Zbgnm */
	dwRet = cp52c_wCmdW(hDevID, 0, (WORD)(((axis & 0x000f) << 8) | 0x19));
	return dwRet;
}

/****************************************************/
/* T[{ZbgIt 								*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hcp52c_SvResetOff(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				/* ߂l */

	/* ԍ0x01`0x0fȊO̎̓G[ */
	if((axis <= 0) || (0x0f < axis))	return ILLEGAL_PRM;

	/* X1 - U1 : wPɃT[{Zbgnee */
	dwRet = cp52c_wCmdW(hDevID, 0, (WORD)(((axis & 0x000f) << 8) | 0x11));
	return dwRet;
}

/****************************************************/
/* pX[^I 								*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hcp52c_PMOn(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				/* ߂l */

	/* ԍ0x01`0x0fȊO̎̓G[ */
	if((axis <= 0) || (0x0f < axis))	return ILLEGAL_PRM;

	/* X1 - U1 : wPɃpX[^nm */
	dwRet = cp52c_wCmdW(hDevID, 0, (WORD)(((axis & 0x000f) << 8) | 0x10));
	return dwRet;
}

/****************************************************/
/* pX[^It 								*/
/* 		FfoCXnhCgݍ킹(HEX)	*/
/****************************************************/
DWORD hcp52c_PMOff(DWORD hDevID, WORD axis)
{
	DWORD	dwRet = 0;				/* ߂l */

	/* ԍ0x01`0x0fȊO̎̓G[ */
	if((axis <= 0) || (0x0f < axis))	return ILLEGAL_PRM;

	/* X1 - U1 : wPɃpX[^nee */
	dwRet = cp52c_wCmdW(hDevID, 0, (WORD)(((axis & 0x000f) << 8) | 0x18));
	return dwRet;
}

/********************************************************/
/* [ǧvZ 									*/
/* 		F[gCԁCeg,			*/
/*				ekC`C\ 					*/
/********************************************************/
DWORD hcp52c_CalAccRate(DWORD* rate, DWORD dwtime, DWORD fh, DWORD fl, WORD pro, WORD s)
{
	double	dblData;
	double	dblTime;
	DWORD	accrate;

	if(!fh)			return ILLEGAL_PRM;
	if(!fl)			return ILLEGAL_PRM;
	if(fh <= fl)	return ILLEGAL_PRM;
	if(!dwtime)		return ILLEGAL_PRM;

	dblTime = (double)dwtime / 1000;		/* (b) */

	if(s) {
	/* ̂r[g:PRUR = 4915200 * ( / (FH - FL)) - 1) */
		dblData = dblTime / (fh - fl + 2 * s);
		dblData = 4915200 * dblData - 1;
		accrate = (DWORD)dblData;
	} else {
		if(pro) {
		/* ̂Ȃr[g:PRUR = 2457600 * ( / (FH - FL)) - 1) */
			dblData = dblTime / (fh - fl);
			dblData = 2457600 * dblData - 1;
			accrate = (DWORD)dblData;
		} else {
		/* [g:PRUR = 4915200 * ( / (FH - FL)) - 1) */
			dblData = dblTime / (fh - fl);
			dblData = 4915200 * dblData - 1;
			accrate = (DWORD)dblData;
		}
	}
	if((accrate > 0xffff) || (!accrate)) 	return ILLEGAL_PRM;
	
	*rate = accrate;
	return 0;
}

//=======================================================
//		ς݊֐ 2007/ 5/24ǉ
//=======================================================
//
// WX^Ǎ
//
DWORD hcp52c_rReg(
		DWORD	hDevID,		// ޲
		WORD	wAxis,		// NO.(0,1,2.. )
		BYTE	byData,		// WX^ǍR}h
		DWORD*	dwData )	// Ǎްi[߲
{
	DWORD	dwRet;

#ifdef APP_SYNC
	EnterCriticalSection(&critSec);
#endif

	dwRet = cp52c_rReg(hDevID, wAxis, byData, dwData);

#ifdef APP_SYNC
	LeaveCriticalSection(&critSec);
#endif

	return dwRet;
}

//
// WX^
//
DWORD hcp52c_wReg(
		DWORD	hDevID,		// ޲
		WORD	wAxis,		// NO.(0,1,2.. )
		BYTE	byData,		// WX^R}h
		DWORD	dwData )	// ڼ޽ް
{
	DWORD	dwRet;

#ifdef APP_SYNC
	EnterCriticalSection(&critSec);
#endif

	dwRet = cp52c_wReg(hDevID, wAxis, byData, dwData);

#ifdef APP_SYNC
	LeaveCriticalSection(&critSec);
#endif

	return dwRet;
}

//
// o̓obt@Ǐo
//		FfoCXnhCԍCo̓obt@ǂݏoꂽf[^i[
DWORD hcp52c_rBufDW(DWORD hDevID, WORD wAxis, DWORD* dwData)
{
	DWORD	dwRet;

#ifdef APP_SYNC
	EnterCriticalSection(&critSec);
#endif

	dwRet = cp52c_rBufDW(hDevID, wAxis, dwData);

#ifdef APP_SYNC
	LeaveCriticalSection(&critSec);
#endif

	return dwRet;
}

//
// o̓obt@
//		FfoCXnhCԍCo̓obt@֏ރf[^
DWORD hcp52c_wBufDW(DWORD hDevID, WORD wAxis, DWORD dwData)
{
	DWORD	dwRet;

#ifdef APP_SYNC
	EnterCriticalSection(&critSec);
#endif

	dwRet = cp52c_wBufDW(hDevID, wAxis, dwData);

#ifdef APP_SYNC
	LeaveCriticalSection(&critSec);
#endif

	return dwRet;
}